// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_common_msgs:msg/CameraParam.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rc_common_msgs/msg/camera_param.hpp"


#ifndef RC_COMMON_MSGS__MSG__DETAIL__CAMERA_PARAM__STRUCT_HPP_
#define RC_COMMON_MSGS__MSG__DETAIL__CAMERA_PARAM__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'line_source'
// Member 'extra_data'
#include "rc_common_msgs/msg/detail/key_value__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_common_msgs__msg__CameraParam __attribute__((deprecated))
#else
# define DEPRECATED__rc_common_msgs__msg__CameraParam __declspec(deprecated)
#endif

namespace rc_common_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CameraParam_
{
  using Type = CameraParam_<ContainerAllocator>;

  explicit CameraParam_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_color_camera = false;
      this->exposure_time = 0.0f;
      this->gain = 0.0f;
      this->line_status_all = 0ul;
    }
  }

  explicit CameraParam_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_color_camera = false;
      this->exposure_time = 0.0f;
      this->gain = 0.0f;
      this->line_status_all = 0ul;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _is_color_camera_type =
    bool;
  _is_color_camera_type is_color_camera;
  using _exposure_time_type =
    float;
  _exposure_time_type exposure_time;
  using _gain_type =
    float;
  _gain_type gain;
  using _line_status_all_type =
    uint32_t;
  _line_status_all_type line_status_all;
  using _line_source_type =
    std::vector<rc_common_msgs::msg::KeyValue_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_common_msgs::msg::KeyValue_<ContainerAllocator>>>;
  _line_source_type line_source;
  using _extra_data_type =
    std::vector<rc_common_msgs::msg::KeyValue_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_common_msgs::msg::KeyValue_<ContainerAllocator>>>;
  _extra_data_type extra_data;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__is_color_camera(
    const bool & _arg)
  {
    this->is_color_camera = _arg;
    return *this;
  }
  Type & set__exposure_time(
    const float & _arg)
  {
    this->exposure_time = _arg;
    return *this;
  }
  Type & set__gain(
    const float & _arg)
  {
    this->gain = _arg;
    return *this;
  }
  Type & set__line_status_all(
    const uint32_t & _arg)
  {
    this->line_status_all = _arg;
    return *this;
  }
  Type & set__line_source(
    const std::vector<rc_common_msgs::msg::KeyValue_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_common_msgs::msg::KeyValue_<ContainerAllocator>>> & _arg)
  {
    this->line_source = _arg;
    return *this;
  }
  Type & set__extra_data(
    const std::vector<rc_common_msgs::msg::KeyValue_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_common_msgs::msg::KeyValue_<ContainerAllocator>>> & _arg)
  {
    this->extra_data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_common_msgs::msg::CameraParam_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_common_msgs::msg::CameraParam_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_common_msgs::msg::CameraParam_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_common_msgs::msg::CameraParam_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_common_msgs::msg::CameraParam_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_common_msgs::msg::CameraParam_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_common_msgs::msg::CameraParam_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_common_msgs::msg::CameraParam_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_common_msgs::msg::CameraParam_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_common_msgs::msg::CameraParam_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_common_msgs__msg__CameraParam
    std::shared_ptr<rc_common_msgs::msg::CameraParam_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_common_msgs__msg__CameraParam
    std::shared_ptr<rc_common_msgs::msg::CameraParam_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraParam_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->is_color_camera != other.is_color_camera) {
      return false;
    }
    if (this->exposure_time != other.exposure_time) {
      return false;
    }
    if (this->gain != other.gain) {
      return false;
    }
    if (this->line_status_all != other.line_status_all) {
      return false;
    }
    if (this->line_source != other.line_source) {
      return false;
    }
    if (this->extra_data != other.extra_data) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraParam_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraParam_

// alias to use template instance with default allocator
using CameraParam =
  rc_common_msgs::msg::CameraParam_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_common_msgs

#endif  // RC_COMMON_MSGS__MSG__DETAIL__CAMERA_PARAM__STRUCT_HPP_
